Raritan PX2/PX3 JSON-RPC API: peripheral::DeviceManager_3_0_2 Interface Reference

Raritan PX2/PX3 JSON-RPC API

Classes | Public Types | Public Member Functions | Public Attributes | List of all members
peripheral::DeviceManager_3_0_2 Interface Reference

Peripheral Device Manager. More...

`import"PeripheralDeviceManager.idl";`

## Classes
struct | DeviceTypeInfo
| Peripheral device type info. More...
struct | FirmwareUpdateState
| Firmware update status. More...
struct | MetaData
| Peripheral DeviceManager's metadata. More...
struct | Settings
| peripheral DeviceManager's s settings More...
struct | Statistics
| Peripheral device statistics. More...

## Public Types
enum | ZCoordMode { RACKUNITS, FREEFORM }
| Z Coordinate Mode identifier. More...
enum | DeviceFirmwareUpdateState { UPDATE_STARTED, UPDATE_SUCCESSFUL, UPDATE_FAILED }
| Enumeration: State of device firmware update. More...

## Public Member Functions
vector< DeviceSlot_2_0_3 > | getDeviceSlots ()
| Get the list of peripheral device slots. More...
DeviceSlot_2_0_3 | getDeviceSlot (in int idx)
| Get a DeviceSlot by its index. More...
vector< Device_3_0_2 > | getDiscoveredDevices ()
| Get the list of currently attached peripheral devices. More...
vector< PackageInfo_2_0_1 > | getDiscoveredPackageInfos ()
| Get the list of currently attached peripheral device packages. More...
Settings | getSettings ()
| Retrieve the peripheral DeviceManager's settings. More...
int | setSettings (in Settings settings)
| Change the peripheral DeviceManager's settings. More...
MetaData | getMetaData ()
| Retreive the Peripheral DeviceManager's metadata. More...
vector< DeviceTypeInfo > | getDeviceTypeInfos ()
| Get the list of all peripheral device type infos. More...
FirmwareUpdateState | getFirmwareUpdateState ()
| Return the state of device firmware updates running on devices connected to this device manager. More...
Statistics | getStatistics ()
| Retrieve statistics. More...
vector< Package_1_0_1 > | getDiscoveredPackages ()
| Get the list of currently attached peripheral device packages. More...
portsmodel::PortFuse | getPortFuse ()
| Get the fuse for the sensor port. More...

## Public Attributes
constant int | ERR_INVALID_PARAMS = 1
| Invalid parameters.
valueobject | SettingsChangedEvent: event::UserEvent { Settings oldSettings
| Event: Peripheral device manager's settings have been changed. More...
Settings | newSettings
| Settings after change.
valueobject | DeviceEvent_2_0_0: idl::Event { vector<Device_3_0_2> devices
| Event: A peripheral device was added or removed. More...
vector< Device_3_0_2 > | allDevices
| New list of discovered devices after change.
valueobject | DeviceAddedEvent_2_0_0: DeviceEvent_2_0_0 { }
| Event: A peripheral device was added.
valueobject | DeviceRemovedEvent_2_0_0: DeviceEvent_2_0_0 { }
| Event: A peripheral device was removed.
valueobject | UnknownDeviceAttachedEvent: idl::Event { string romCode
| Event: An unknown device was attached. More...
vector< PosElement > | position
| Device position in the chain.
valueobject | DeviceFirmwareUpdateStateChangedEvent: idl::Event { string oldVersion
| Event: Firmware update on a device was started or has finished. More...
string | newVersion
| Firmware version to be updated to.
string | serial
| Serial number of device.
DeviceFirmwareUpdateState | state
| Update state.
valueobject | FirmwareUpdateStateChangedEvent: idl::Event { FirmwareUpdateState newState
| Event: Firmware update state has changed This event will be sent to enclose one of more DeviceFirmwareUpdateStateChangedEvent. More...
valueobject | PackageEvent_2_0_0: idl::Event { vector<PackageInfo_2_0_1> packageInfos
| Event: A peripheral device package was added or removed. More...
vector< PackageInfo_2_0_1 > | allPackages
| New list of discovered packages after change.
valueobject | PackageAddedEvent_2_0_0: PackageEvent_2_0_0 { }
| Event: A peripheral device package was added.
valueobject | PackageRemovedEvent_2_0_0: PackageEvent_2_0_0 { }
| Event: A peripheral device package was removed.

## Detailed Description

Peripheral Device Manager.

## Member Enumeration Documentation

## ◆ DeviceFirmwareUpdateState

enum peripheral::DeviceManager_3_0_2::DeviceFirmwareUpdateState

Enumeration: State of device firmware update.

Enumerator
UPDATE_STARTED | Update is running.
UPDATE_SUCCESSFUL | Update has finished successfully.
UPDATE_FAILED | Update has failed.

## ◆ ZCoordMode

enum peripheral::DeviceManager_3_0_2::ZCoordMode

Z Coordinate Mode identifier.

Enumerator
RACKUNITS | Z coordinate of slot settings is in rack units.
FREEFORM | Z coordinate of slot settings is free form text.

## Member Function Documentation

## ◆ getDeviceSlot()

DeviceSlot_2_0_3 peripheral::DeviceManager_3_0_2::getDeviceSlot | ( | in int | idx | ) |

Get a DeviceSlot by its index.

Parameters

  idx | index of the slot to get

Returns
  the requested slot

## ◆ getDeviceSlots()

vector<DeviceSlot_2_0_3> peripheral::DeviceManager_3_0_2::getDeviceSlots | ( |  | ) |

Get the list of peripheral device slots.

Returns
  List of peripheral device slots

## ◆ getDeviceTypeInfos()

vector<DeviceTypeInfo> peripheral::DeviceManager_3_0_2::getDeviceTypeInfos | ( |  | ) |

Get the list of all peripheral device type infos.

Returns
  List of all peripheral device type infos

## ◆ getDiscoveredDevices()

vector<Device_3_0_2> peripheral::DeviceManager_3_0_2::getDiscoveredDevices | ( |  | ) |

Get the list of currently attached peripheral devices.

Returns
  List of all discovered peripheral devices

## ◆ getDiscoveredPackageInfos()

vector<PackageInfo_2_0_1> peripheral::DeviceManager_3_0_2::getDiscoveredPackageInfos | ( |  | ) |

Get the list of currently attached peripheral device packages.

Returns
  List of all discovered peripheral device packages

## ◆ getDiscoveredPackages()

vector<Package_1_0_1> peripheral::DeviceManager_3_0_2::getDiscoveredPackages | ( |  | ) |

Get the list of currently attached peripheral device packages.

Returns
  List of all discovered peripheral device packages

## ◆ getFirmwareUpdateState()

FirmwareUpdateState peripheral::DeviceManager_3_0_2::getFirmwareUpdateState | ( |  | ) |

Return the state of device firmware updates running on devices connected to this device manager.

Returns
  Firmware update state

## ◆ getMetaData()

MetaData peripheral::DeviceManager_3_0_2::getMetaData | ( |  | ) |

Retreive the Peripheral DeviceManager's metadata.

Returns
  Peripheral DeviceManager's metadata

## ◆ getPortFuse()

portsmodel::PortFuse peripheral::DeviceManager_3_0_2::getPortFuse | ( |  | ) |

Get the fuse for the sensor port.

Returns
  A fuse instance, if available

## ◆ getSettings()

Settings peripheral::DeviceManager_3_0_2::getSettings | ( |  | ) |

Retrieve the peripheral DeviceManager's settings.

Returns
  peripheral DeviceManager's settings

## ◆ getStatistics()

Statistics peripheral::DeviceManager_3_0_2::getStatistics | ( |  | ) |

Retrieve statistics.

Returns
  peripheral device statistics

## ◆ setSettings()

int peripheral::DeviceManager_3_0_2::setSettings | ( | in Settings | settings | ) |

Change the peripheral DeviceManager's settings.

Parameters

  settings | New peripheral DeviceManager's settings

Returns
  0 if OK
  ERR_INVALID_PARAMS if any parameters are invalid

## Member Data Documentation

## ◆ DeviceEvent_2_0_0

valueobject peripheral::DeviceManager_3_0_2::DeviceEvent_2_0_0

Event: A peripheral device was added or removed.

Affected devices

## ◆ DeviceFirmwareUpdateStateChangedEvent

valueobject peripheral::DeviceManager_3_0_2::DeviceFirmwareUpdateStateChangedEvent

Event: Firmware update on a device was started or has finished.

Firmware version before update

## ◆ FirmwareUpdateStateChangedEvent

valueobject peripheral::DeviceManager_3_0_2::FirmwareUpdateStateChangedEvent

Event: Firmware update state has changed This event will be sent to enclose one of more DeviceFirmwareUpdateStateChangedEvent.

That is, it will be sent before a series of firmware updates is started and after the firmware update series has ended. New update state

## ◆ PackageEvent_2_0_0

valueobject peripheral::DeviceManager_3_0_2::PackageEvent_2_0_0

Event: A peripheral device package was added or removed.

Information about affected packages

## ◆ SettingsChangedEvent

valueobject peripheral::DeviceManager_3_0_2::SettingsChangedEvent

Event: Peripheral device manager's settings have been changed.

Settings before change

## ◆ UnknownDeviceAttachedEvent

valueobject peripheral::DeviceManager_3_0_2::UnknownDeviceAttachedEvent

Event: An unknown device was attached.

Device ROM code

The documentation for this interface was generated from the following file:

- pdu-json-rpc-api/idl/PeripheralDeviceManager.idl